Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/ComponentUtils.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/ComponentUtils.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/ComponentUtils.java	(revision 5549)
@@ -1,4 +1,5 @@
 package clarin.cmdi.componentregistry.impl;
 
+import clarin.cmdi.componentregistry.ComponentRegistryException;
 import java.text.ParseException;
 import java.util.ArrayList;
@@ -11,5 +12,4 @@
 import org.springframework.beans.BeanUtils;
 
-import clarin.cmdi.componentregistry.DatesHelper;
 import clarin.cmdi.componentregistry.model.BaseDescription;
 import clarin.cmdi.componentregistry.model.ComponentDescription;
@@ -18,58 +18,56 @@
 /**
  * Utilities for working with {@link BaseDescription}s
- * 
+ *
  * @author george.georgovassilis@mpi.nl
- * 
+ *
  */
 public class ComponentUtils {
 
     public static boolean isProfileId(String componentId) {
-	return ("" + componentId).startsWith(ProfileDescription.PROFILE_PREFIX);
+        return ("" + componentId).startsWith(ProfileDescription.PROFILE_PREFIX);
     }
 
     public static boolean isComponentId(String componentId) {
-	return ("" + componentId)
-		.startsWith(ComponentDescription.COMPONENT_PREFIX);
+        return ("" + componentId)
+                .startsWith(ComponentDescription.COMPONENT_PREFIX);
     }
 
     public static void copyPropertiesFrom(BaseDescription from, BaseDescription to) {
-	BeanUtils.copyProperties(from, to);
+        BeanUtils.copyProperties(from, to);
     }
 
     public static Date getDate(String registrationDate) throws ParseException {
-	return DateUtils.parseDate(registrationDate,
-		new String[] { DateFormatUtils.ISO_DATETIME_TIME_ZONE_FORMAT
-			.getPattern() });
+        return DateUtils.parseDate(registrationDate,
+                new String[]{DateFormatUtils.ISO_DATETIME_TIME_ZONE_FORMAT
+                    .getPattern()});
     }
 
     public static String createPublicHref(String href) {
-	String result = href;
-	if (href != null) {
-	    int index = href.indexOf("?");
-	    if (index != -1) { // strip off query params the rest should be the
-			       // public href.
-		result = href.substring(0, index);
-	    }
-	}
-	return result;
+        String result = href;
+        if (href != null) {
+            int index = href.indexOf("?");
+            if (index != -1) { // strip off query params the rest should be the
+                // public href.
+                result = href.substring(0, index);
+            }
+        }
+        return result;
     }
-
     /**
-     * Compares two descriptions by the their value as returned by
-     * {@link BaseDescription#getName()
+     * Compares two descriptions by the their value as returned by      {@link BaseDescription#getName()
      * }
      */
     public static final Comparator<? super BaseDescription> COMPARE_ON_NAME = new Comparator<BaseDescription>() {
-	@Override
-	public int compare(BaseDescription o1, BaseDescription o2) {
-	    int result = 0;
-	    if (o1.getName() != null && o2.getName() != null) {
-		result = o1.getName().compareToIgnoreCase(o2.getName());
-	    }
-	    if (o1.getId() != null && result == 0) {
-		result = o1.getId().compareTo(o2.getId());
-	    }
-	    return result;
-	}
+        @Override
+        public int compare(BaseDescription o1, BaseDescription o2) {
+            int result = 0;
+            if (o1.getName() != null && o2.getName() != null) {
+                result = o1.getName().compareToIgnoreCase(o2.getName());
+            }
+            if (o1.getId() != null && result == 0) {
+                result = o1.getId().compareTo(o2.getId());
+            }
+            return result;
+        }
     };
     /**
@@ -78,49 +76,68 @@
      */
     public static final Comparator<? super BaseDescription> COMPARE_ON_DATE = new Comparator<BaseDescription>() {
-	/**
-	 * @returns 1 if o11 is older than o2, returns -1 if o1 is younger than
-	 *          o2
-	 */
-	@Override
-	public int compare(BaseDescription o1, BaseDescription o2) {
-	    return o1.getRegistrationDate().compareTo(o2.getRegistrationDate());
-	}
+        /**
+         * @returns 1 if o11 is older than o2, returns -1 if o1 is younger than
+         * o2
+         */
+        @Override
+        public int compare(BaseDescription o1, BaseDescription o2) {
+            return o1.getRegistrationDate().compareTo(o2.getRegistrationDate());
+        }
     };
 
-    public static ProfileDescription toProfile(BaseDescription baseDescription) {
-	if (baseDescription == null)
-	    return null;
-	ProfileDescription copy = new ProfileDescription();
-	BeanUtils.copyProperties(baseDescription, copy);
-	return copy;
+    public static ProfileDescription toProfile(BaseDescription baseDescription) throws ComponentRegistryException {
+        if (baseDescription == null) {
+            return null;
+        }
+        if (baseDescription.getId().startsWith(ProfileDescription.PROFILE_PREFIX)) {
+            ProfileDescription copy = new ProfileDescription();
+            BeanUtils.copyProperties(baseDescription, copy);
+            return copy;
+        } else {
+            throw new ComponentRegistryException("The item is not a profile.");
+        }
     }
 
-    public static ComponentDescription toComponent(BaseDescription baseDescription) {
-	if (baseDescription == null)
-	    return null;
-	ComponentDescription copy = new ComponentDescription();
-	BeanUtils.copyProperties(baseDescription, copy);
-	return copy;
+    public static ComponentDescription toComponent(BaseDescription baseDescription) throws ComponentRegistryException {
+        if (baseDescription == null) {
+            return null;
+        }
+        if (baseDescription.getId().startsWith(ComponentDescription.COMPONENT_PREFIX)) {
+            ComponentDescription copy = new ComponentDescription();
+            BeanUtils.copyProperties(baseDescription, copy);
+            return copy;
+        } else {
+            throw new ComponentRegistryException("The item is not a component");
+        }
     }
 
     public static List<ProfileDescription> toProfiles(
-	    List<BaseDescription> baseDescription) {
-	if (baseDescription == null)
-	    return null;
-	List<ProfileDescription> list = new ArrayList<ProfileDescription>();
-	for (BaseDescription c : baseDescription)
-	    list.add(toProfile(c));
-	return list;
+            List<BaseDescription> baseDescription) {
+        if (baseDescription == null) {
+            return null;
+        }
+        List<ProfileDescription> list = new ArrayList<ProfileDescription>();
+        for (BaseDescription c : baseDescription) {
+            try {
+                list.add(toProfile(c));
+            } catch (ComponentRegistryException e) {
+            }
+        }
+        return list;
     }
 
     public static List<ComponentDescription> toComponents(
-	    List<BaseDescription> baseDescription) {
-	if (baseDescription == null)
-	    return null;
-	List<ComponentDescription> list = new ArrayList<ComponentDescription>();
-	for (BaseDescription c : baseDescription)
-	    list.add(toComponent(c));
-	return list;
+            List<BaseDescription> baseDescription) {
+        if (baseDescription == null) {
+            return null;
+        }
+        List<ComponentDescription> list = new ArrayList<ComponentDescription>();
+        for (BaseDescription c : baseDescription) {
+            try {
+                list.add(toComponent(c));
+            } catch (ComponentRegistryException e) {
+            }
+        }
+        return list;
     }
-
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/AdminRegistry.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/AdminRegistry.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/AdminRegistry.java	(revision 5549)
@@ -14,8 +14,8 @@
 import clarin.cmdi.componentregistry.ComponentRegistryException;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
-import clarin.cmdi.componentregistry.ComponentStatus;
 import clarin.cmdi.componentregistry.DeleteFailedException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
 import clarin.cmdi.componentregistry.MDMarshaller;
-import clarin.cmdi.componentregistry.OwnerUser;
+import clarin.cmdi.componentregistry.UserCredentials;
 import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
@@ -54,5 +54,10 @@
 
     public void submitFile(CMDItemInfo info, Principal userPrincipal)
-	    throws SubmitFailedException {
+	    throws SubmitFailedException, UserUnauthorizedException {
+        if (userPrincipal == null) {
+            LOG.info("Null user principal, nothings is submitted.");
+            return;
+        }
+        
 	try {
 	    BaseDescription originalDescription = info.getDataNode()
@@ -72,8 +77,6 @@
 		    IOUtils.toInputStream(info.getContent(), "UTF-8"), null);
 	    checkId(originalDescription.getId(), description.getId());
-
-	    int result = getRegistry(userPrincipal, originalDescription, info)
-		    .update(description, spec, userPrincipal,
-			    info.isForceUpdate());
+            ComponentRegistry cr = this.getRegistry(new UserCredentials(userPrincipal));
+	    int result = cr.update(description, spec, info.isForceUpdate());
 	    if (result < 0) {
 		throw new SubmitFailedException(
@@ -83,4 +86,6 @@
 	    throw new SubmitFailedException(e);
 	} catch (IOException e) {
+	    throw new SubmitFailedException(e);
+	} catch (ItemNotFoundException e) {
 	    throw new SubmitFailedException(e);
 	}
@@ -109,5 +114,5 @@
 	BaseDescription desc = info.getDataNode().getDescription();
 	try {
-	    deleteFromRegistry(userPrincipal, desc, info);
+	    this.deleteFromRegistry(userPrincipal, desc, info);
 	    LOG.info("Deleted item: " + id);
 	} catch (IOException e) {
@@ -119,4 +124,6 @@
 	} catch (ComponentRegistryException e) {
 	    throw new SubmitFailedException(e);
+	} catch (ItemNotFoundException e) {
+	    throw new SubmitFailedException(e);
 	}
 
@@ -125,30 +132,23 @@
     private void deleteFromRegistry(Principal userPrincipal,
 	    BaseDescription desc, CMDItemInfo info) throws IOException,
-	    UserUnauthorizedException, ComponentRegistryException {
-	ComponentRegistry registry = getRegistry(userPrincipal, desc, info);
+	    UserUnauthorizedException, ComponentRegistryException, ItemNotFoundException {
+        
+        if (userPrincipal == null) {
+           LOG.info("Bnull user principal, nothing is deleted"); 
+           return;
+        }
+        
+	ComponentRegistry registry = this.getRegistry(new UserCredentials(userPrincipal));
 	LOG.info("Deleting item: " + desc);
 	if (desc.isProfile()) {
-	    registry.deleteMDProfile(desc.getId(), userPrincipal);
+	    registry.deleteMDProfile(desc.getId());
 	} else {
-	    registry.deleteMDComponent(desc.getId(), userPrincipal,
-		    info.isForceUpdate());
+	    registry.deleteMDComponent(desc.getId(), info.isForceUpdate());
 	}
     }
 
-    private ComponentRegistry getRegistry(Principal userPrincipal,
-	    BaseDescription desc, CMDItemInfo info) {
-	ComponentRegistry registry = componentRegistryFactory
-		.getPublicRegistry();
-	// TODO: More generic check
-	if (info.getStatus() == ComponentStatus.PRIVATE /*
-							 * || info.getStatus()
-							 * == ComponentStatus.
-							 * DEVELOPMENT
-							 */) {
-	    registry = componentRegistryFactory.getOtherUserComponentRegistry(
-		    userPrincipal, info.getStatus(),
-		    new OwnerUser(Integer.parseInt(desc.getUserId())));
-	}
-	return registry;
-    }
+    private ComponentRegistry getRegistry(UserCredentials credentials) throws UserUnauthorizedException{
+        return componentRegistryFactory.getBaseRegistry(credentials);
+        }
+    
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/ComponentRegistryDbImpl.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/ComponentRegistryDbImpl.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/impl/database/ComponentRegistryDbImpl.java	(revision 5549)
@@ -4,12 +4,14 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
-import clarin.cmdi.componentregistry.ComponentStatus;
 import clarin.cmdi.componentregistry.Configuration;
 import clarin.cmdi.componentregistry.DeleteFailedException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
 import clarin.cmdi.componentregistry.MDMarshaller;
 import clarin.cmdi.componentregistry.Owner;
 import clarin.cmdi.componentregistry.OwnerUser;
+import clarin.cmdi.componentregistry.RegistrySpace;
 import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
+import clarin.cmdi.componentregistry.components.CMDComponentType;
 import clarin.cmdi.componentregistry.impl.ComponentRegistryImplBase;
 import clarin.cmdi.componentregistry.impl.ComponentUtils;
@@ -17,4 +19,5 @@
 import clarin.cmdi.componentregistry.model.Comment;
 import clarin.cmdi.componentregistry.model.ComponentDescription;
+import clarin.cmdi.componentregistry.model.Group;
 import clarin.cmdi.componentregistry.model.ProfileDescription;
 import clarin.cmdi.componentregistry.model.RegistryUser;
@@ -30,5 +33,4 @@
 import java.io.UnsupportedEncodingException;
 import java.security.Principal;
-import java.text.ParseException;
 import java.util.ArrayList;
 import java.util.Calendar;
@@ -51,5 +53,5 @@
  * Implementation of ComponentRegistry that uses Database Acces Objects for
  * accessing the registry (ergo: a database implementation)
- * 
+ *
  * @author Twan Goosen <twan.goosen@mpi.nl>
  * @author George.Georgovassilis@mpi.nl
